- hosts: [a, b]
  become: true
  vars:
    a: 
      vni: 47
      eth1: 10.0.0.1/24
      local: 10.0.0.1
      remote: 10.0.0.99
      br0:  172.30.0.1/24
    b: 
      vni: 48
      eth1: 10.0.0.2/24
      local: 10.0.0.2
      remote: 10.0.0.99
      br0:  172.30.0.2/24
  tasks:

    - name: install networking utilities
      apt:
        name:
          - ethtool
          - tcpdump
        state: latest

    - name: configure link
      blockinfile:
        path: /etc/network/interfaces
        block: |
          auto eth1
          iface eth1 inet static
            address {{vars[inventory_hostname_short].eth1}}

    - name: bring up eth1
      shell: ifup eth1

    - name: turn off tx checksum offload
      shell: ethtool --offload eth1 tx off

    - name: setup bridge
      shell: "{{item}}"
      loop:
        - ip link add br0 type bridge
        - ip addr add {{vars[inventory_hostname_short].br0}} dev br0
        - ip link set up dev br0
      ignore_errors: yes

    - name: setup vxlan
      shell: "{{item}}"
      loop: 
        - ip link add vxlan{{vars[inventory_hostname_short].vni}} type vxlan id {{vars[inventory_hostname_short].vni}} dstport 4789 local {{vars[inventory_hostname_short].local}}
        - ip link set master br0 dev vxlan{{vars[inventory_hostname_short].vni}}
        - ip link set up dev vxlan{{vars[inventory_hostname_short].vni}}
        - bridge fdb append 00:00:00:00:00:00 dev vxlan{{vars[inventory_hostname_short].vni}} dst {{vars[inventory_hostname_short].remote}}
      ignore_errors: yes
